import { ExtendedRepositoryPort } from '@mobicoop/ddd-library';
import { AdEntity } from '../../domain/ad.entity';
import { AlgorithmType, Candidate } from '../types/algorithm.types';
import { Frequency } from '../../domain/ad.types';

export type AdRepositoryPort = ExtendedRepositoryPort<AdEntity> & {
  getCandidates(query: CandidateQuery): Promise<Candidate[]>;
};

export type CandidateQuery = {
  driver: boolean;
  passenger: boolean;
  strict: boolean;
  frequency: Frequency;
  fromDate: string;
  toDate: string;
  schedule: {
    day?: number;
    time: string;
    margin?: number;
  }[];
  algorithmType: AlgorithmType;
};
