import { QueryBase } from '@mobicoop/ddd-library';
import { AlgorithmType } from '../../types/algorithm.types';
import { Waypoint } from '../../types/waypoint.type';
import { ScheduleItem } from '../../types/schedule-item.type';
import { Frequency } from '@modules/ad/core/domain/ad.types';

export class MatchQuery extends QueryBase {
  readonly driver: boolean;
  readonly passenger: boolean;
  readonly frequency: Frequency;
  readonly fromDate: string;
  readonly toDate: string;
  readonly schedule: ScheduleItem[];
  readonly strict: boolean;
  readonly waypoints: Waypoint[];
  readonly algorithmType: AlgorithmType;

  constructor(props: MatchQuery) {
    super();
    this.driver = props.driver;
    this.passenger = props.passenger;
    this.frequency = props.frequency;
    this.fromDate = props.fromDate;
    this.toDate = props.toDate;
    this.schedule = props.schedule;
    this.strict = props.strict;
    this.waypoints = props.waypoints;
    this.algorithmType = props.algorithmType;
  }
}
